<?php
/**
 * @package		Drewmla.extensions
 * @subpackage	mod_charismanewswidget
 */

defined('_JEXEC') or die;

$class_sfx = htmlspecialchars($class_sfx);
$errs = array();

// Use the Custom Configuration Code field if it's set, otherwise look at the various widget parameters to build the config
$useCustomConfig	= $params->get('use_custom_config', false);
$customConfig		= $params->get('customConfig');

if($useCustomConfig && !empty($customConfig))
{

	preg_match('~id(\s)*:(\s)*"([^"]*)"~i',$customConfig,$matches);
	$placeholderId = $matches[3];

	// Sanatize data
	$placeholderId		= preg_replace('~[^-_a-z0-9]~i','', $placeholderId);

	// Check for invalid data
	if(!strlen($placeholderId))
	{
		$errs[] = "The <em>Placeholder ID</em> that you entered is invalid. Please make sure you use only a-z, 0-9, - (dash), and _ (underscore).";
	}

	$configOut = PHP_EOL.$customConfig.PHP_EOL;

}
else
{

	// Get data
	$config = array();
	if($params->get('widthCheck',true))
	{
		$config['width'] = '100%';
	}
	else
	{
		$config['width'] = (int) $params->get('customWidth','300');
	}
	if($params->get('heightCheck',true))
	{
		$config['height'] = '0';
	}
	else
	{
		$config['height'] = (int) $params->get('customHeight','0');
	}
	$config['title']		= (int) $params->get('title','1');
	$config['title_logo']	= (int) $params->get('title_logo','1');
	$config['description']	= (int) $params->get('description','1');
	$config['teaser']		= (int) $params->get('teasers','1');
	$config['max_chars']	= (int) $params->get('teaserLength','300');
	$config['date']			= (int) $params->get('date','1');
	$config['images']		= (int) $params->get('images','1');
	$config['image_size']	= (int) $params->get('image_size','150');
	$config['id']			= $params->get('placeholder_id','chm_widgets_cno');
	$config['max_items']	= (int) $params->get('numArticles','5');

	// Sanatize data
	$config['id']			= preg_replace('~[^-_a-z0-9]~i','', $config['id']);

	// Build config string
	$configOut = PHP_EOL.'CNO_Widget_Config = {'.PHP_EOL.'//<![CDATA['.PHP_EOL;
	foreach($config as $k => $v)
	{
		$configOut .= "	{$k}: \"{$v}\",".PHP_EOL;
	}
	$configOut = substr($configOut,0,-2).PHP_EOL;
	$configOut .= '}'.PHP_EOL.'//]]>'.PHP_EOL;

	// Check for invalid data
	if(!strlen($config['id']))
	{
		$errs[] = "The <em>Placeholder ID</em> that you entered is invalid. Please make sure you use only a-z, 0-9, - (dash), and _ (underscore).";
	}

	$placeholderId = $config['id'];

}

if(count($errs))
{

	require JModuleHelper::getLayoutPath('mod_charismanewswidget', 'errors');

}
else
{

	$document = JFactory::getDocument();
	$document->addScript("https://charismanews.com/widgets/cno/0.4/cno.js");
	$document->addScriptDeclaration($configOut);

	require JModuleHelper::getLayoutPath('mod_charismanewswidget', $params->get('layout', 'default'));
}
